# std::current_exception

From cppreference.com
< cpp‎ | error

Defined in header `<exception>` |  |
std::exception_ptr current_exception(); |  | (since C++11)

If called during exception handling (typically, in a catch clause), captures the current exception object and creates an std::exception_ptr that holds either a copy or a reference to that exception object (depending on the implementation). The referenced object remains valid at least as long as there is an `exception_ptr` object that refers to it.

If the implementation of this function requires a call to new and the call fails, the returned pointer will hold a reference to an instance of std::bad_alloc.

If the implementation of this function requires copying the captured exception object and its copy constructor throws an exception, the returned pointer will hold a reference to the exception thrown. If the copy constructor of the thrown exception object also throws, the returned pointer may hold a reference to an instance of std::bad_exception to break the endless loop.

If the function is called when no exception is being handled, an empty std::exception_ptr is returned.

### Parameters

(none)

### Return value

An instance of std::exception_ptr holding a reference to the exception object, or a copy of the exception object, or to an instance of std::bad_alloc or to an instance of std::bad_exception.

### Exceptions

`noexcept` specification:
noexcept

### Example

Run this code

    #include <iostream>
    #include <string>
    #include <exception>
    #include <stdexcept>

    void handle_eptr(std::exception_ptr eptr) // passing by value is ok
    {
        try {
            if (eptr) {
                std::rethrow_exception(eptr);
            }
        } catch(const std::exception& e) {
            std::cout << "Caught exception \"" << e.what() << "\"\n";
        }
    }

    int main()
    {
        std::exception_ptr eptr;
        try {
            std::string().at(1); // this generates an std::out_of_range
        } catch(...) {
            eptr = std::current_exception(); // capture
        }
        handle_eptr(eptr);
    } // destructor for std::out_of_range called here, when the eptr is destructed

Output:

    Caught exception "basic_string::at"

### See also

exception_ptr (C++11) | shared pointer type for handling exception objects (typedef)
rethrow_exception (C++11) | throws the exception from an std::exception_ptr (function)
make_exception_ptr (C++11) | creates an std::exception_ptr from an exception object (function template)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/error/current_exception&oldid=91642"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template